<template>
  <div id="login">
    <!-- Title -->
    <b-card-title>
      {{ $t("page.login.title") }}
    </b-card-title>

    <transition name="component-fade" mode="out-in">
      <!-- Institutions -->
      <Institution
        v-if="showInstitutions"
        @closeInstitutionSelection="showInstitutions = false"
        @confirmInstitutionSelection="toInstitutionLoginPage"
      />

      <!-- Buttons -->
      <div v-else class="v_gapped_container">
        <!-- Institution Shibboleth Login -->
        <b-button
          v-if="selectedInstitution && !isFirstLogin"
          variant="primary"
          @click="toInstitutionLoginPage"
        >
          {{ selectedInstitution.displayName }}
        </b-button>
        <!-- Institutional Account -->
        <b-button variant="primary" @click="switchInstitution">
          {{ institutionButtonText }}
        </b-button>

        <!-- NFDI4Ing AAI Login Button -->
        <b-button variant="primary" @click.prevent="toNFDI4IngAAILoginPage">
          <img
            class="d-inline me-2 position-relative"
            style="width: 2.5rem; top: -0.1rem"
            alt="NFDI sign in key"
            src="@/assets/svg/NFDI_key_icon.svg"
          />
          <span>{{ $t("page.login.button_nfdi4IngAai") }}</span>
        </b-button>

        <!-- ORCID Login Button -->
        <b-button variant="primary" @click.prevent="toOrcidLoginPage">
          <img
            class="d-inline me-1"
            style="width: 1.5rem"
            alt="ORCID logo"
            src="@/assets/svg/ORCIDiD_iconvector.svg"
          />
          <span>{{ $t("page.login.button_orcid") }}</span>
        </b-button>
      </div>
    </transition>
  </div>
</template>

<script lang="ts">
import Institution from "./Institution.vue";
import type { DFNAAIInstitution } from "../types";
import type { LoginUrls } from "@coscine/api-client/dist/types/Coscine.Api.STS";

// import the store for current module
import useLoginStore from "../store";

export default defineComponent({
  components: {
    Institution,
  },

  setup() {
    const loginStore = useLoginStore();

    return { loginStore };
  },

  data() {
    return {
      showInstitutions: false,
    };
  },

  computed: {
    selectedInstitution(): DFNAAIInstitution | null {
      return this.loginStore.selectedInstitution;
    },
    loginUrls(): LoginUrls | null {
      return this.loginStore.loginUrls;
    },
    redirectUrl(): string | null {
      const query = this.$route.query["redirect"];
      return query ? (query as string) : null;
    },
    isFirstLogin(): boolean {
      return !this.selectedInstitution;
    },
    institutionButtonText(): string {
      return this.isFirstLogin
        ? this.$t("page.login.button_institution").toString()
        : this.$t("page.login.button_other_institution").toString();
    },
  },

  created() {
    this.fixMalformedLoginStoredData(); // TODO: Remove this from March 2023
  },

  methods: {
    //-----------------------------------------------------------------
    // Method necessary only temporarily. Needed due to the fixed JSON
    // format before the UI migration of login. Leave it in for the
    // time being, to ensure backwards compatibility with an already
    // chosen institution inside the local storage's storedData. This
    // is a one time fix for data conforming to the old schema. Can be
    // removed from March 2023. Also edit the store type to use object.
    fixMalformedLoginStoredData() {
      const loginStoredData: string = this.loginStore.loginStoredData;
      if (loginStoredData && loginStoredData.trim() !== "") {
        this.loginStore.loginStoredData = loginStoredData
          .replace("entityID", "entityId")
          .replace("DisplayName", "displayName")
          .replace("Logo", "logo");
      }
    },
    //-----------------------------------------------------------------
    toOrcidLoginPage() {
      const url = new URL(window.location.href);
      url.pathname = `/coscine/api/v2/self/session/${this.loginStore.orcidId}`;

      // TODO: Remove the following line after STS retirement
      // Trigger logout to ensure clean session data
      this.loginStore.logout();

      window.location.href = url.toString();
    },

    toNFDI4IngAAILoginPage() {
      const url = new URL(window.location.href);
      url.pathname = `/coscine/api/v2/self/session/${this.loginStore.nfdi4IngAaiId}`;

      // TODO: Remove the following line after STS retirement
      // Trigger logout to ensure clean session data
      this.loginStore.logout();

      window.location.href = url.toString();
    },

    toInstitutionLoginPage() {
      if (
        this.selectedInstitution &&
        this.selectedInstitution.entityId.trim() !== ""
      ) {
        let returnUrl = `/coscine/api/Coscine.Api.STS/Shibboleth/login?entityId=${this.selectedInstitution.entityId}`;
        if (this.redirectUrl && this.redirectUrl.trim() !== "") {
          returnUrl += `&returnUrl=${this.redirectUrl}`;
        }
        // TODO: Remove the following line after STS retirement
        // Trigger logout to ensure clean session data
        this.loginStore.logout();

        window.location.href = window.location.origin + returnUrl;
      }
    },

    switchInstitution() {
      this.showInstitutions = true;
    },
  },
});
</script>

<style scoped>
.component-fade-enter-active,
.component-fade-leave-active {
  transition: opacity 0.2s ease;
}
.component-fade-enter,
.component-fade-leave-to {
  opacity: 0;
}
</style>
